﻿namespace BinarySearch.State;

/// <summary>
/// Класс-состояние
/// </summary>
[Serializable]
public class SearchState
{
    public int Left { get; }
    public int Right { get; }
    public int Mid { get; }
    public List<int> Array {  get; }
    public int Target { get; }
    public int? TargetIndex { get; }

    /// <summary>
    /// Конструктор класса состояния
    /// </summary>
    /// <param name="left"></param>
    /// <param name="right"></param>
    /// <param name="mid"></param>
    /// <param name="targetIndex"></param>
    /// <param name="array"></param>
    /// <param name="target"></param>
    public SearchState(int left, int right, int mid, int? targetIndex, List<int> array, int target)
    {
        Left = left;
        Right = right;
        Mid = mid;
        TargetIndex = targetIndex;
        Array = array;
        Target = target;
    }
}
